<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AccessibilityStructure StructType
 * Meta informations extracted from the WSDL
 * - documentation: Type for accessibility.
 * @subpackage Structs
 */
class AccessibilityStructure extends \EnumType\AccessibilityEnumeration
{
    /**
     * The _
     * @var string
     */
    public $_;
    /**
     * Constructor method for AccessibilityStructure
     * @uses AccessibilityStructure::set_()
     * @param string $_
     */
    public function __construct($_ = null)
    {
        $this
            ->set_($_);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @uses \EnumType\AccessibilityEnumeration::valueIsValid()
     * @uses \EnumType\AccessibilityEnumeration::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $_
     * @return \StructType\AccessibilityStructure
     */
    public function set_($_ = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AccessibilityEnumeration::valueIsValid($_)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $_, implode(', ', \EnumType\AccessibilityEnumeration::getValidValues())), __LINE__);
        }
        $this->_ = $_;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AccessibilityStructure
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
